String.prototype.replaceAll = function (find, replace) {
    var result = this;
    do {
        var split = result.split(find);
        result = split.join(replace);
    } while (split.length > 1);
    return result;
};

function save_options() {
    browser.storage.sync.set({
        "add": $('#add').value
    }, function () {});
    browser.storage.sync.set({
        "vervangen": $('#vervangen').value.replaceAll('\n', '<br>')
    }, function () {});
    browser.storage.sync.set({
        "track": $('#track').value.replaceAll('\n', '<br>')
    }, function () {});
    browser.storage.sync.set({
        "type": $('#type').value
    }, function () {});
    browser.storage.sync.set({
        "hideOtherLogs": $('#hideOtherLogs').attr('checked')
    })
}

function standaard() {
    standaard = "Dit is mijn [NUMMER]e gevonden cache.\nBij deze bedank ik [LEGGER] voor het leggen en onderhouden van '[CACHE]'.\nCachen is voor mij een gezonde verslaving.\nGevonden op [YYYY]/[MM]/[DD].\n\n[NAAM]";
    standaardtrack = "Ik heb [TRACKABLE] van [EIGENAAR] gezien bij [GC].\nCachen is voor mij een gezonde verslaving.\nGevonden op [YYYY]/[MM]/[DD].\n\n[NAAM]";
    standaard = standaard.replaceAll('\\n', '<br>');
    standaardtrack = standaardtrack.replaceAll('\\n', '<br>');
    $('#vervangen').value=standaard;
    $('#track').value=standaardtrack;
    $('#type').value=-1;
    $('#hideOtherLogs').attr('checked',false)
    save_options();
}

function restore_options() {

    browser.storage.sync.get({
        "add": 1
    }, function (items) {
        $("#add").value=parseInt(items.add);
    });
    standaard = "NOG NIET INGESTELD. klik op standaard.";
    browser.storage.sync.get({
        "vervangen": standaard
    }, function (items) {
        $("#vervangen").value=items.vervangen.replaceAll('<br>', '\n');
    });
    browser.storage.sync.get({
        "track": standaard
    }, function (items) {
        $("#track").value=items.track.replaceAll('<br>', '\n');
    });
    browser.storage.sync.get({
        "type": -1
    }, function (items) {
        $("#type").value=items.type;
    });
    browser.storage.sync.get({
        "hideOtherLogs": true
    }, function (items) {
        $('#hideOtherLogs').attr('checked',items.hideOtherLogs);
    })
}

function clear() {
    browser.storage.sync.clear(function () {})
}
document.addEventListener('DOMContentLoaded', restore_options);
$('#save').on('click', save_options);
$('#clear').on('click', clear);
$('#standaard').on('click', standaard);

var data;
var smiley;
var url;
fetch('https://www.geocaching.com/guide/markdown.aspx').then(data=>data.text()).then(function (responseData) {
    $("#smileys").html(responseData);
    var result = $("#smileys").find(".smiley-guide").first().find("table").first().find(".td__column"); //getElementsByTagName("tbody")[0]
    var string = "";
    for(i = 0;i < result.length; i++)
    {
        for(y = 0;y < result.get(i).find("tr").length; y++)
        {
            string+='<span title="'+result.get(i).find("tr").get(y).find("td").get(2).html()[0]+'">'+result.get(i).find("tr").get(y).find("td").first().html()[0]+'</span>';
        }
    }
    string=string.replaceAll("../", "https://www.geocaching.com/");
    $("#smileys").html(string);
});
