String.prototype.replaceAll = function (find, replace) {
    var result = this;
    do {
        var split = result.split(find);
        result = split.join(replace);
    } while (split.length > 1);
    return result;
};
$('#go-to-options').on('click', ()=>{
	if (chrome.runtime.openOptionsPage) {
    chrome.runtime.openOptionsPage();
  } else {
    window.open(chrome.runtime.getURL('options.html'));
  }
});
$('#smileybutton').on('click', ()=>{
	buttons(false);
	hideall();
	$('#smileys').removeAttr("hidden");
	var data;
	var smiley;
	var url;      
        fetch('https://www.geocaching.com/guide/markdown.aspx').then(data=>data.text()).then(function (responseData) {
		$("#smileys").html(responseData);
		var result = $("#smileys").find(".smiley-guide").first().find("table").first().find(".td__column"); //getElementsByTagName("tbody")[0]
		var string = "";
		for(i = 0;i < result.length; i++)
		{
			for(y = 0;y < result.get(i).find("tr").length; y++)
			{
				string+='<span title="'+result.get(i).find("tr").get(y).find("td").get(2).html()[0]+'">'+result.get(i).find("tr").get(y).find("td").first().html()[0]+'</span>';
			}
		}
		string=string.replaceAll("../", "https://www.geocaching.com/");
		$("#smileys").html(string);
	});
});

function buttons (state) {
	if (state) {
		$('.buttons').removeAttr("hidden");
		$('#back').attr("hidden", "true");
	}else{
		$('#buttons').attr("hidden", "true");
		$('#back').removeAttr('hidden');
	}
}
function hideall () {
	$('#view').attr("hidden", "true");
	$('#loggen').attr("hidden", "true");
	$('#loggen').attr("hidden", "true");
	$('#track').attr("hidden", "true");
	
}

$('#logbutton').on('click', function () {
	buttons(false);
	hideall();
	$('#loggen').removeAttr("hidden");
	$("#loggengc").focus();
	$('#submitlog').on('click', function() {
		if($("#loggengc").value.toUpperCase().substring(0, 2) == "GC") {
			window.open('https://geocaching.com/seek/log.aspx?wp='+$('#loggengc').value);
		}
		else if($("#loggengc").value.toUpperCase().substring(0, 2) == "TB") {
			window.open('https://www.geocaching.com/track/log.aspx?wp='+$("#loggengc").value);
		}
		else
		{
			window.open('https://www.geocaching.com/track/details.aspx?gotolog=true&tracker='+$("#loggengc").value);
		}
	});
});

$('#viewbutton').on('click', function () {
	buttons(false);
	hideall();
	$('#view').removeAttr("hidden");
	$("#viewgc")[0].focus();
	$('#submitview').on('click', function() {
		if(($("#viewgc").value.toUpperCase().substring(0, 2) == "TB")||($("#viewgc").value.toUpperCase().substring(0, 2) == "GC")) {
			window.open('https://coord.info/'+$("#viewgc").value);
		}
		else
		{
			window.open('https://www.geocaching.com/track/details.aspx?tracker='+$("#viewgc").value);
		}
	});
});      
$('#reload').on('click', function () {
	chrome.runtime.reload();
});

$('#back').on('click', function () {
	hideall();
	buttons(true);
});

$('#expand').on('click', function () {
	window.open(chrome.runtime.getURL('geocaching/popup.html'));
});
function loadBanners() {
	browser.storage.sync.get({"banners": []}, function(banners) {
		string='';
		banners.banners.forEach(function (banner) {
			string+=banner+'\n\n';
		});
		$("#banners").innerText=string;
	});
}
$("#deletebanners").on('click', function () {
	browser.storage.sync.remove("banners", function () {
		loadBanners();
	});
});
loadBanners();
function loadCaches() {
	browser.storage.sync.get({"caches": []}, function (caches) {
		string='';
		caches.caches.forEach(function (cache) {
			string+=cache+'\n';
		});
		$("#caches").innerText=string
	})
}
$("#deletecaches").on('click', function () {
	browser.storage.sync.remove("caches", function () {
		loadCaches()
	})
});
loadCaches();
