function addTextAtCaret(textAreaId, text) {
	var textArea = document.getElementById(textAreaId);
	var cursorPosition = textArea.selectionStart;
	addTextAtCursorPosition(textArea, cursorPosition, text);
	updateCursorPosition(cursorPosition, text, textArea);
}
function addTextAtCursorPosition(textArea, cursorPosition, text) {
	var front = (textArea.value).substring(0, cursorPosition);
	var back = (textArea.value).substring(cursorPosition, textArea.value.length);
	textArea.value = front + text + back;
}
function updateCursorPosition(cursorPosition, text, textArea) {
	cursorPosition = cursorPosition + text.length;
	textArea.selectionStart = cursorPosition;
	textArea.selectionEnd = cursorPosition;
	textArea.focus();
}